﻿Public Class APT
    'GOTOコマンドの処理
    Shared Sub mw_GOTO(ByVal input_str As String)
        Dim i, data_num As Integer
        Dim work_str_arr() As String
        Dim x, y, z, x1, y1, z1, dx, dy, dz, dist0 As Double
        Dim vx, vy, vz As Double
        Dim coo(3), joint_angle(3), number_line(256, 2) As Double
        Dim servo_data(3) As Integer


        work_str_arr = input_str.Split(",")
        x = Val(work_str_arr(0))
        y = Val(work_str_arr(1))
        z = Val(work_str_arr(2))

        x1 = frmPgmMode.last_coo(0)
        y1 = frmPgmMode.last_coo(1)
        z1 = frmPgmMode.last_coo(2)

        dx = x - x1
        dy = y - y1
        dz = z - z1

        dist0 = (dx ^ 2 + dy ^ 2 + dz ^ 2) ^ 0.5

        vx = dx / dist0
        vy = dy / dist0
        vz = dz / dist0

        data_num = frmPgmMode.feed_rate
        '加速・減速パターンの数直線　取得
        NumberLine.type1b(number_line, dist0, data_num)

        For i = 1 To data_num - 1
            coo(0) = x1 + vx * number_line(i, 0)
            coo(1) = y1 + vy * number_line(i, 0)
            coo(2) = z1 + vz * number_line(i, 0)
            JointCalc.coo2servo3ax(coo, servo_data, joint_angle)

            For j = 0 To 2
                frmUtils.servo_data_present_deg(j) = joint_angle(j)
                frmUtils.servo_data_present(j) = servo_data(j)
                frmPgmMode.last_coo(j) = coo(j)
            Next
            frmPgmMode.txtCooX.Text = Format(coo(0), "0.0")
            frmPgmMode.txtCooY.Text = Format(coo(1), "0.0")
            frmPgmMode.txtCooZ.Text = Format(coo(2), "0.0")
            frmPgmMode.txtCooX.Refresh()
            frmPgmMode.txtCooY.Refresh()
            frmPgmMode.txtCooZ.Refresh()

            frmPgmMode.move_servo(frmUtils.servo_data_present_deg)
        Next

    End Sub
End Class
