﻿Public Class JointPlm

    '関節パラメータファイル　読取
    Shared Sub fwrite_convtab(ByVal pal_fname As String)

        Dim work_str As String
        Dim i, j, k As Integer

        'ファイルを使うときの番号
        Dim in_filenum_work As Integer = 95
        Dim out_filenum_work As Integer = 96

        work_str = ""
        'palファイル書き込み
        If IO.File.Exists(pal_fname) Then
            FileOpen(out_filenum_work, pal_fname, OpenMode.Output)

            'servo data 腕＆腰
            PrintLine(out_filenum_work, frmUtils.servo_st_en_area_name(i, 0))
            For j = 0 To 7
                work_str = frmUtils.servo_st_en_field_name(i, j)
                For k = 0 To 5
                    work_str = work_str + ", "
                    work_str = work_str + Format(frmUtils.servo_st_en(i, j, k))
                Next k
                PrintLine(out_filenum_work, work_str)
            Next j
            FileClose(out_filenum_work)
        Else
            MsgBox(pal_fname + "ファイルが見つかりません。")
            Exit Sub
        End If

    End Sub

    '関節パラメータファイル　読取
    Shared Sub fread_convtab(ByVal pal_fname As String)

        Dim work_str, work_str_arr() As String
        Dim i, j, k As Integer

        'ファイルを使うときの番号
        Dim in_filenum_work As Integer = 95
        Dim out_filenum_work As Integer = 96

        'palファイル読取
        If IO.File.Exists(pal_fname) Then
            FileOpen(in_filenum_work, pal_fname, OpenMode.Input)

            'servo data
            frmUtils.servo_st_en_area_name(i, 0) = LineInput(in_filenum_work)
            For j = 0 To 7
                work_str = LineInput(in_filenum_work)
                work_str_arr = work_str.Split(",")

                frmUtils.servo_st_en_field_name(i, j) = work_str_arr(0)
                For k = 0 To 5
                    frmUtils.servo_st_en(i, j, k) = Val(work_str_arr(k + 1))
                Next k
            Next j

            FileClose(in_filenum_work)
        Else
            MsgBox(pal_fname + "ファイルが見つかりません。")
            Exit Sub
        End If
    End Sub
    '関節パラメータファイル　読取（骨格、変換テーブル、可動範囲込み）
    Shared Sub fread_pal(ByVal pal_fname As String)

        Dim work_str, work_str_arr() As String
        Dim i, j, k As Integer

        'ファイルを使うときの番号
        Dim in_filenum_work As Integer = 95
        Dim out_filenum_work As Integer = 96

        i = 0

        'palファイル読取
        If IO.File.Exists(pal_fname) Then
            FileOpen(in_filenum_work, pal_fname, OpenMode.Input)

            'Bone Length
            frmUtils.bone_area_name(i) = LineInput(in_filenum_work)
            For j = 0 To 1
                work_str = LineInput(in_filenum_work)
                work_str_arr = work_str.Split(",")

                frmUtils.bone_field_name(i, j) = work_str_arr(0)
                frmUtils.bone_length(i, j) = Val(work_str_arr(1))
            Next j

            'servo min/max
            frmUtils.servo_min_max_area_name(i, 0) = LineInput(in_filenum_work)
            For j = 0 To 7
                work_str = LineInput(in_filenum_work)
                work_str_arr = work_str.Split(",")

                frmUtils.servo_min_max_field_name(i, j) = work_str_arr(0)
                For k = 0 To 1
                    frmUtils.servo_min_max(i, j, k) = Val(work_str_arr(k + 1))
                Next k
            Next j

            FileClose(in_filenum_work)
        Else
            MsgBox(pal_fname + "ファイルが見つかりません。")
            Exit Sub
        End If

    End Sub

End Class
