﻿Imports System.IO

Public Class frmMain

    Private Sub frmMain_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim i As Integer
        Dim work_str_arr(32) As String

        Values.inits()

        work_str_arr = IO.Ports.SerialPort.GetPortNames
        For i = 0 To work_str_arr.Length - 1

            'LPC1768 posrt
            comboSIO1.Items.Add(work_str_arr(i))

        Next

    End Sub

    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        End
    End Sub

    '調整ボタンの処理
    Private Sub btnUtils_Click(sender As System.Object, e As System.EventArgs) Handles btnUtils.Click

        'シリアルポートが開いているかチェック
        If Me.SerialPort1.IsOpen = False Then
            MsgBox("先に「接続」して下さい")
        Else
            'マイコンからの起動メッセージ等を破棄
            Me.SerialPort1.DiscardInBuffer()
        End If

        frmPlmEdit.Visible = True
        frmUtils.Visible = True
        Me.Visible = False

    End Sub

    '「接続」ボタンの処理*******************************
    Private Sub btnComSwitch_Click(sender As System.Object, e As System.EventArgs) Handles btnComSwitch.Click
        'Dim a As Double
        Dim response As MsgBoxResult
        Dim buff(64) As Byte

        'ポートが既に開かれているかチェック
        If Me.SerialPort1.IsOpen = False Then
            Try
                Me.SerialPort1.BaudRate = Me.ComboBox1.Text
                Me.SerialPort1.PortName = Me.comboSIO1.Text
                'ポートオープン
                Me.SerialPort1.Open()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポート（ロボット内蔵メインＣＰＵ通信用）" + Me.comboSIO1.Text + "のオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            Catch ex As UnauthorizedAccessException
                response = MsgBox("エラー！シリアルポート（ロボット内蔵メインＣＰＵ通信用）" + Me.comboSIO1.Text + "のオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            End Try
            If Me.SerialPort1.IsOpen = True Then
                'ボタンの色を動作中色に変更
                Me.btnComSwitch.BackColor = Values.active_button_color

                '電池電圧データ取込（単発）
                'SIO.write_command("M")

            End If

        Else
            Try
                'ポートクローズ
                Me.SerialPort1.Close()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポート（ロボット内蔵メインＣＰＵ通信用）" + Me.comboSIO1.Text + "のクローズに失敗しました。", MsgBoxStyle.Information)
            End Try
            If Me.SerialPort1.IsOpen = False Then
                'ボタンの色をフォームの背景色に変更
                Me.btnComSwitch.BackColor = Values.org_back_color
            End If
        End If
    End Sub

End Class
