﻿Public Class frmPlmEdit

    '←　ボタンの処理
    Private Sub btnDown_S_Click(sender As System.Object, e As System.EventArgs) Handles btnDown_S.Click

        Dim a, diff As Double

        If radioShift.Checked = True Then
            'シフトモード（左、中央、右の数値を同じだけ増減する）
            diff = Val(txtShiftDiff.Text)
            If (Val(txtLeftRaw.Text) - Val(txtMidRaw.Text)) > 0 Then diff = diff * -1
            txtLeftRaw.Text = Format(Val(txtLeftRaw.Text) - diff)
            txtMidRaw.Text = Format(Val(txtMidRaw.Text) - diff)
            txtRightRaw.Text = Format(Val(txtRightRaw.Text) - diff)
        Else
            'ジョイントパラメータ　右側点
            If radioLeft.Checked = True Then
                a = Val(txtMidRaw.Text) - Val(txtLeftRaw.Text)
                diff = a * Val(txtPropotionDiff.Text) / 100
                a = Val(txtLeftRaw.Text) - diff
                txtLeftRaw.Text = Format(a, "#####")
            End If

            'ジョイントパラメータ　左側点
            If radioRight.Checked = True Then
                a = Val(txtRightRaw.Text) - Val(txtMidRaw.Text)
                diff = a * Val(txtPropotionDiff.Text) / 100
                a = Val(txtRightRaw.Text) - diff
                txtRightRaw.Text = Format(a, "#####")
            End If
        End If

        Me.reflect_st_en()

    End Sub

    '→　ボタンの処理
    Private Sub btnUp_S_Click(sender As System.Object, e As System.EventArgs) Handles btnUp_S.Click

        Dim a, diff As Double

        If radioShift.Checked = True Then
            'シフトモード（左、中央、右の数値を同じだけ増減する）
            diff = Val(txtShiftDiff.Text)
            If (Val(txtRightRaw.Text) - Val(txtMidRaw.Text)) < 0 Then diff = diff * -1
            txtLeftRaw.Text = Format(Val(txtLeftRaw.Text) + diff)
            txtMidRaw.Text = Format(Val(txtMidRaw.Text) + diff)
            txtRightRaw.Text = Format(Val(txtRightRaw.Text) + diff)
        Else
            'ジョイントパラメータ　右側点
            If radioLeft.Checked = True Then
                a = Val(txtMidRaw.Text) - Val(txtLeftRaw.Text)
                diff = a * Val(txtPropotionDiff.Text) / 100
                a = Val(txtLeftRaw.Text) + diff
                txtLeftRaw.Text = Format(a, "#####")
            End If

            'ジョイントパラメータ　左側点
            If radioRight.Checked = True Then
                a = Val(txtRightRaw.Text) - Val(txtMidRaw.Text)
                diff = a * Val(txtPropotionDiff.Text) / 100
                a = Val(txtRightRaw.Text) + diff
                txtRightRaw.Text = Format(a, "#####")
            End If
        End If

        Me.reflect_st_en()

    End Sub

    'アップダウンボタンで編集した結果をservo_st_en変数へ反映する
    Private Sub reflect_st_en()
        Dim i, id, id2 As Integer

        id = cmbJointSelect.SelectedIndex
        If id < 11 Then
            i = 0
            id2 = id + 11
        Else
            i = 1
            id = id - 11
            id2 = id
        End If

        frmUtils.servo_st_en(i, id, 0) = Val(txtLeftDeg.Text)
        frmUtils.servo_st_en(i, id, 1) = Val(txtLeftRaw.Text)
        frmUtils.servo_st_en(i, id, 2) = Val(txtMidDeg.Text)
        frmUtils.servo_st_en(i, id, 3) = Val(txtMidRaw.Text)
        frmUtils.servo_st_en(i, id, 4) = Val(txtRightDeg.Text)
        frmUtils.servo_st_en(i, id, 5) = Val(txtRightRaw.Text)

        If frmUtils.radioRaw.Checked = True Then
            'Raw Modeの時は直接出力用のテキストボックスと同期
            If radioLeft.Checked = True Then
                frmUtils.ar_textbox(id2).Text = txtLeftRaw.Text
            End If
            If radioMid.Checked = True Then
                frmUtils.ar_textbox(id2).Text = txtMidRaw.Text
            End If
            If radioRight.Checked = True Then
                frmUtils.ar_textbox(id2).Text = txtRightRaw.Text
            End If

            frmUtils.ar_radiobutton(id2).Checked = True
        End If

    End Sub

    'コンボボックスでパラメータを編集する関節番号を選んだ時の処理
    Private Sub cmbJointSelect_TextChanged(sender As Object, e As System.EventArgs) Handles cmbJointSelect.TextChanged
        Dim i, id As Integer

        id = cmbJointSelect.SelectedIndex
        If id < 11 Then
            i = 0
        Else
            i = 1
            id = id - 11
        End If

        txtLeftDeg.Text = frmUtils.servo_st_en(i, id, 0)
        txtLeftRaw.Text = frmUtils.servo_st_en(i, id, 1)
        txtMidDeg.Text = frmUtils.servo_st_en(i, id, 2)
        txtMidRaw.Text = frmUtils.servo_st_en(i, id, 3)
        txtRightDeg.Text = frmUtils.servo_st_en(i, id, 4)
        txtRightRaw.Text = frmUtils.servo_st_en(i, id, 5)

    End Sub

    Private Sub radioPropotion_CheckedChanged(sender As Object, e As System.EventArgs) Handles radioPropotion.CheckedChanged
        radioMid.Enabled = False
    End Sub

    Private Sub radioShift_CheckedChanged(sender As Object, e As System.EventArgs) Handles radioShift.CheckedChanged
        radioMid.Enabled = True
    End Sub
End Class